#include <iostream>
#include <objbase.h>

#include "COMHelper.h"
#include "IFace.h"

using namespace std;

void trace(char * msg) { cout << msg << "\n"; }
void trerr(char * msg, HRESULT hr);

int main()
{
CoInitialize(NULL);
trace("Client:\tCall CoCreateInstance.");

IJason* pIJason = NULL;
HRESULT hr = ::CoCreateInstance(CLSID_CJason, NULL, CLSCTX_INPROC_SERVER,
                                IID_IJason, (void**)&pIJason);

if(SUCCEEDED(hr))
{
    trace("Client:\tCoCreateInstance succeeded.  IJason recieved.");

    trace("Client:\tSaying `Hello' to COM world through IJason.");
    pIJason->fHelloCOMWorld();

    trace("Client:\tAsking CJason to say something through IJason.");
    pIJason->fSaySomething();

    trace("Client:\tReleasing IJason; finished with interface.");
    pIJason->Release();
}
else
{
    trerr("Client:\tCould not get interface.  CoCreateInstance failed.", hr);
}

CoUninitialize();
return 0;
}

void trerr(char * msg, HRESULT hr)
{
void* pBuffer;

::FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
                NULL, hr, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
                (LPTSTR)&pBuffer, 0, NULL);


cout << "ERROR:\nmsg:\t" << msg << "\nhr:\t(" << hex << hr << ") "
        << (LPTSTR)pBuffer << endl;

LocalFree(pBuffer);
}

